

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Kconfig Language &mdash; Xen 4.16-unstable documentation</title>
  

  
  
  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../_static/css/theme.css" type="text/css" />
  

  

  
        <link rel="index" title="Index"
              href="../genindex.html"/>
        <link rel="search" title="Search" href="../search.html"/>
    <link rel="top" title="Xen 4.16-unstable documentation" href="../index.html"/> 

  
  <script src="../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../index.html" class="icon icon-home"> Xen
          

          
          </a>

          
            
            
              <div class="version">
                4.16
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../admin-guide/index.html">Admin Guide</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../guest-guide/index.html">Guest documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../hypervisor-guide/index.html">Hypervisor documentation</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../hypercall-interfaces/index.html">Hypercall Interfaces</a></li>
</ul>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../glossary.html">Glossary</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../index.html">Xen</a>
        
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../index.html">Docs</a> &raquo;</li>
        
      <li>Kconfig Language</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../_sources/misc/kconfig-language.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <div class="section" id="kconfig-language">
<h1>Kconfig Language<a class="headerlink" href="#kconfig-language" title="Permalink to this headline">¶</a></h1>
<div class="section" id="introduction">
<h2>Introduction<a class="headerlink" href="#introduction" title="Permalink to this headline">¶</a></h2>
<p>The configuration database is a collection of configuration options
organized in a tree structure:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>+- Code maturity level options
|  +- Prompt for development and/or incomplete code/drivers
+- General setup
|  +- Networking support
|  +- System V IPC
|  +- BSD Process Accounting
|  +- Sysctl support
+- Loadable module support
|  +- Enable loadable module support
|     +- Set version information on all module symbols
|     +- Kernel module loader
+- ...
</pre></div>
</div>
<p>Every entry has its own dependencies. These dependencies are used
to determine the visibility of an entry. Any child entry is only
visible if its parent entry is also visible.</p>
</div>
<div class="section" id="menu-entries">
<h2>Menu entries<a class="headerlink" href="#menu-entries" title="Permalink to this headline">¶</a></h2>
<p>Most entries define a config option; all other entries help to organize
them. A single configuration option is defined like this:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config MODVERSIONS
      bool &quot;Set version information on all module symbols&quot;
      depends on MODULES
      help
        Usually, modules have to be recompiled whenever you switch to a new
        kernel.  ...
</pre></div>
</div>
<p>Every line starts with a key word and can be followed by multiple
arguments.  “config” starts a new config entry. The following lines
define attributes for this config option. Attributes can be the type of
the config option, input prompt, dependencies, help text and default
values. A config option can be defined multiple times with the same
name, but every definition can have only a single input prompt and the
type must not conflict.</p>
</div>
<div class="section" id="menu-attributes">
<h2>Menu attributes<a class="headerlink" href="#menu-attributes" title="Permalink to this headline">¶</a></h2>
<p>A menu entry can have a number of attributes. Not all of them are
applicable everywhere (see syntax).</p>
<ul>
<li><p class="first">type definition: “bool”/”tristate”/”string”/”hex”/”int”</p>
<p>Every config option must have a type. There are only two basic types:
tristate and string; the other types are based on these two. The type
definition optionally accepts an input prompt, so these two examples
are equivalent:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>bool &quot;Networking support&quot;
</pre></div>
</div>
<p>and:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>bool
prompt &quot;Networking support&quot;
</pre></div>
</div>
</li>
<li><p class="first">input prompt: “prompt” &lt;prompt&gt; [“if” &lt;expr&gt;]</p>
<p>Every menu entry can have at most one prompt, which is used to display
to the user. Optionally dependencies only for this prompt can be added
with “if”.</p>
</li>
<li><p class="first">default value: “default” &lt;expr&gt; [“if” &lt;expr&gt;]</p>
<p>A config option can have any number of default values. If multiple
default values are visible, only the first defined one is active.
Default values are not limited to the menu entry where they are
defined. This means the default can be defined somewhere else or be
overridden by an earlier definition.
The default value is only assigned to the config symbol if no other
value was set by the user (via the input prompt above). If an input
prompt is visible the default value is presented to the user and can
be overridden by him.
Optionally, dependencies only for this default value can be added with
“if”.</p>
</li>
</ul>
<blockquote>
<div><p>The default value deliberately defaults to ‘n’ in order to avoid bloating the
build. With few exceptions, new config options should not change this. The
intent is for “make oldconfig” to add as little as possible to the config from
release to release.</p>
<dl class="docutils">
<dt>Note:</dt>
<dd><p class="first">Things that merit “default y/m” include:</p>
<ol class="last loweralpha simple">
<li>A new Kconfig option for something that used to always be built
should be “default y”.</li>
<li>A new gatekeeping Kconfig option that hides/shows other Kconfig
options (but does not generate any code of its own), should be
“default y” so people will see those other options.</li>
<li>Sub-driver behavior or similar options for a driver that is
“default n”. This allows you to provide sane defaults.</li>
<li>Hardware or infrastructure that everybody expects, such as CONFIG_NET
or CONFIG_BLOCK. These are rare exceptions.</li>
</ol>
</dd>
</dl>
</div></blockquote>
<ul>
<li><p class="first">type definition + default value:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;def_bool&quot;/&quot;def_tristate&quot; &lt;expr&gt; [&quot;if&quot; &lt;expr&gt;]
</pre></div>
</div>
<p>This is a shorthand notation for a type definition plus a value.
Optionally dependencies for this default value can be added with “if”.</p>
</li>
<li><p class="first">dependencies: “depends on” &lt;expr&gt;</p>
<p>This defines a dependency for this menu entry. If multiple
dependencies are defined, they are connected with ‘&amp;&amp;’. Dependencies
are applied to all other options within this menu entry (which also
accept an “if” expression), so these two examples are equivalent:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>bool &quot;foo&quot; if BAR
default y if BAR
</pre></div>
</div>
<p>and:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>depends on BAR
bool &quot;foo&quot;
default y
</pre></div>
</div>
</li>
<li><p class="first">reverse dependencies: “select” &lt;symbol&gt; [“if” &lt;expr&gt;]</p>
<p>While normal dependencies reduce the upper limit of a symbol (see
below), reverse dependencies can be used to force a lower limit of
another symbol. The value of the current menu symbol is used as the
minimal value &lt;symbol&gt; can be set to. If &lt;symbol&gt; is selected multiple
times, the limit is set to the largest selection.
Reverse dependencies can only be used with boolean or tristate
symbols.</p>
<dl class="docutils">
<dt>Note:</dt>
<dd><p class="first last">select should be used with care. select will force
a symbol to a value without visiting the dependencies.
By abusing select you are able to select a symbol FOO even
if FOO depends on BAR that is not set.
In general use select only for non-visible symbols
(no prompts anywhere) and for symbols with no dependencies.
That will limit the usefulness but on the other hand avoid
the illegal configurations all over.</p>
</dd>
</dl>
</li>
<li><p class="first">weak reverse dependencies: “imply” &lt;symbol&gt; [“if” &lt;expr&gt;]</p>
<p>This is similar to “select” as it enforces a lower limit on another
symbol except that the “implied” symbol’s value may still be set to n
from a direct dependency or with a visible prompt.</p>
<p>Given the following example:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config FOO
    tristate
    imply BAZ

config BAZ
    tristate
    depends on BAR
</pre></div>
</div>
<p>The following values are possible:</p>
<blockquote>
<div><table border="1" class="docutils">
<colgroup>
<col width="9%" />
<col width="9%" />
<col width="39%" />
<col width="42%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">FOO</th>
<th class="head">BAR</th>
<th class="head">BAZ’s default</th>
<th class="head">choice for BAZ</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>n</td>
<td>y</td>
<td>n</td>
<td>N/m/y</td>
</tr>
<tr class="row-odd"><td>m</td>
<td>y</td>
<td>m</td>
<td>M/y/n</td>
</tr>
<tr class="row-even"><td>y</td>
<td>y</td>
<td>y</td>
<td>Y/n</td>
</tr>
<tr class="row-odd"><td>y</td>
<td>n</td>
<td><ul class="first last simple">
<li></li>
</ul>
</td>
<td>N</td>
</tr>
</tbody>
</table>
</div></blockquote>
<p>This is useful e.g. with multiple drivers that want to indicate their
ability to hook into a secondary subsystem while allowing the user to
configure that subsystem out without also having to unset these drivers.</p>
</li>
<li><p class="first">limiting menu display: “visible if” &lt;expr&gt;</p>
<p>This attribute is only applicable to menu blocks, if the condition is
false, the menu block is not displayed to the user (the symbols
contained there can still be selected by other symbols, though). It is
similar to a conditional “prompt” attribute for individual menu
entries. Default value of “visible” is true.</p>
</li>
<li><p class="first">numerical ranges: “range” &lt;symbol&gt; &lt;symbol&gt; [“if” &lt;expr&gt;]</p>
<p>This allows to limit the range of possible input values for int
and hex symbols. The user can only input a value which is larger than
or equal to the first symbol and smaller than or equal to the second
symbol.</p>
</li>
<li><p class="first">help text: “help” or “—help—”</p>
<p>This defines a help text. The end of the help text is determined by
the indentation level, this means it ends at the first line which has
a smaller indentation than the first line of the help text.
“—help—” and “help” do not differ in behaviour, “—help—” is
used to help visually separate configuration logic from help within
the file as an aid to developers.</p>
</li>
<li><p class="first">misc options: “option” &lt;symbol&gt;[=&lt;value&gt;]</p>
<p>Various less common options can be defined via this option syntax,
which can modify the behaviour of the menu entry and its config
symbol. These options are currently possible:</p>
<ul class="simple">
<li>“defconfig_list”
This declares a list of default entries which can be used when
looking for the default configuration (which is used when the main
.config doesn’t exists yet.)</li>
<li>“modules”
This declares the symbol to be used as the MODULES symbol, which
enables the third modular state for all config symbols.
At most one symbol may have the “modules” option set.</li>
<li>“allnoconfig_y”
This declares the symbol as one that should have the value y when
using “allnoconfig”. Used for symbols that hide other symbols.</li>
</ul>
</li>
</ul>
</div>
<div class="section" id="menu-dependencies">
<h2>Menu dependencies<a class="headerlink" href="#menu-dependencies" title="Permalink to this headline">¶</a></h2>
<p>Dependencies define the visibility of a menu entry and can also reduce
the input range of tristate symbols. The tristate logic used in the
expressions uses one more state than normal boolean logic to express the
module state. Dependency expressions have the following syntax:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&lt;expr&gt; ::= &lt;symbol&gt;                           (1)
         &lt;symbol&gt; &#39;=&#39; &lt;symbol&gt;                (2)
         &lt;symbol&gt; &#39;!=&#39; &lt;symbol&gt;               (3)
         &lt;symbol1&gt; &#39;&lt;&#39; &lt;symbol2&gt;              (4)
         &lt;symbol1&gt; &#39;&gt;&#39; &lt;symbol2&gt;              (4)
         &lt;symbol1&gt; &#39;&lt;=&#39; &lt;symbol2&gt;             (4)
         &lt;symbol1&gt; &#39;&gt;=&#39; &lt;symbol2&gt;             (4)
         &#39;(&#39; &lt;expr&gt; &#39;)&#39;                       (5)
         &#39;!&#39; &lt;expr&gt;                           (6)
         &lt;expr&gt; &#39;&amp;&amp;&#39; &lt;expr&gt;                   (7)
         &lt;expr&gt; &#39;||&#39; &lt;expr&gt;                   (8)
</pre></div>
</div>
<p>Expressions are listed in decreasing order of precedence.</p>
<ol class="arabic simple">
<li>Convert the symbol into an expression. Boolean and tristate symbols
are simply converted into the respective expression values. All
other symbol types result in ‘n’.</li>
<li>If the values of both symbols are equal, it returns ‘y’,
otherwise ‘n’.</li>
<li>If the values of both symbols are equal, it returns ‘n’,
otherwise ‘y’.</li>
<li>If value of &lt;symbol1&gt; is respectively lower, greater, lower-or-equal,
or greater-or-equal than value of &lt;symbol2&gt;, it returns ‘y’,
otherwise ‘n’.</li>
<li>Returns the value of the expression. Used to override precedence.</li>
<li>Returns the result of (2-/expr/).</li>
<li>Returns the result of min(/expr/, /expr/).</li>
<li>Returns the result of max(/expr/, /expr/).</li>
</ol>
<p>An expression can have a value of ‘n’, ‘m’ or ‘y’ (or 0, 1, 2
respectively for calculations). A menu entry becomes visible when its
expression evaluates to ‘m’ or ‘y’.</p>
<p>There are two types of symbols: constant and non-constant symbols.
Non-constant symbols are the most common ones and are defined with the
‘config’ statement. Non-constant symbols consist entirely of alphanumeric
characters or underscores.
Constant symbols are only part of expressions. Constant symbols are
always surrounded by single or double quotes. Within the quote, any
other character is allowed and the quotes can be escaped using ‘’.</p>
</div>
<div class="section" id="menu-structure">
<h2>Menu structure<a class="headerlink" href="#menu-structure" title="Permalink to this headline">¶</a></h2>
<p>The position of a menu entry in the tree is determined in two ways. First
it can be specified explicitly:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>menu &quot;Network device support&quot;
      depends on NET

config NETDEVICES
      ...

endmenu
</pre></div>
</div>
<p>All entries within the “menu” … “endmenu” block become a submenu of
“Network device support”. All subentries inherit the dependencies from
the menu entry, e.g. this means the dependency “NET” is added to the
dependency list of the config option NETDEVICES.</p>
<p>The other way to generate the menu structure is done by analyzing the
dependencies. If a menu entry somehow depends on the previous entry, it
can be made a submenu of it. First, the previous (parent) symbol must
be part of the dependency list and then one of these two conditions
must be true:</p>
<ul>
<li><p class="first">the child entry must become invisible, if the parent is set to ‘n’</p>
</li>
<li><p class="first">the child entry must only be visible, if the parent is visible:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config MODULES
    bool &quot;Enable loadable module support&quot;

config MODVERSIONS
    bool &quot;Set version information on all module symbols&quot;
    depends on MODULES

comment &quot;module support disabled&quot;
    depends on !MODULES
</pre></div>
</div>
</li>
</ul>
<p>MODVERSIONS directly depends on MODULES, this means it’s only visible if
MODULES is different from ‘n’. The comment on the other hand is only
visible when MODULES is set to ‘n’.</p>
</div>
<div class="section" id="kconfig-syntax">
<h2>Kconfig syntax<a class="headerlink" href="#kconfig-syntax" title="Permalink to this headline">¶</a></h2>
<p>The configuration file describes a series of menu entries, where every
line starts with a keyword (except help texts). The following keywords
end a menu entry:</p>
<ul class="simple">
<li>config</li>
<li>menuconfig</li>
<li>choice/endchoice</li>
<li>comment</li>
<li>menu/endmenu</li>
<li>if/endif</li>
<li>source</li>
</ul>
<p>The first five also start the definition of a menu entry.</p>
<p>config:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;config&quot; &lt;symbol&gt;
&lt;config options&gt;
</pre></div>
</div>
<p>This defines a config symbol &lt;symbol&gt; and accepts any of above
attributes as options.</p>
<p>menuconfig:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;menuconfig&quot; &lt;symbol&gt;
&lt;config options&gt;
</pre></div>
</div>
<p>This is similar to the simple config entry above, but it also gives a
hint to front ends, that all suboptions should be displayed as a
separate list of options. To make sure all the suboptions will really
show up under the menuconfig entry and not outside of it, every item
from the &lt;config options&gt; list must depend on the menuconfig symbol.
In practice, this is achieved by using one of the next two constructs:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>(1):
menuconfig M
if M
    config C1
    config C2
endif

(2):
menuconfig M
config C1
    depends on M
config C2
    depends on M
</pre></div>
</div>
<p>In the following examples (3) and (4), C1 and C2 still have the M
dependency, but will not appear under menuconfig M anymore, because
of C0, which doesn’t depend on M:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>(3):
menuconfig M
    config C0
if M
    config C1
    config C2
endif

(4):
menuconfig M
config C0
config C1
    depends on M
config C2
    depends on M
</pre></div>
</div>
<p>choices:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;choice&quot; [symbol]
&lt;choice options&gt;
&lt;choice block&gt;
&quot;endchoice&quot;
</pre></div>
</div>
<p>This defines a choice group and accepts any of the above attributes as
options. A choice can only be of type bool or tristate.  If no type is
specified for a choice, its type will be determined by the type of
the first choice element in the group or remain unknown if none of the
choice elements have a type specified, as well.</p>
<p>While a boolean choice only allows a single config entry to be
selected, a tristate choice also allows any number of config entries
to be set to ‘m’. This can be used if multiple drivers for a single
hardware exists and only a single driver can be compiled/loaded into
the kernel, but all drivers can be compiled as modules.</p>
<p>A choice accepts another option “optional”, which allows to set the
choice to ‘n’ and no entry needs to be selected.
If no [symbol] is associated with a choice, then you can not have multiple
definitions of that choice. If a [symbol] is associated to the choice,
then you may define the same choice (i.e. with the same entries) in another
place.</p>
<p>comment:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;comment&quot; &lt;prompt&gt;
&lt;comment options&gt;
</pre></div>
</div>
<p>This defines a comment which is displayed to the user during the
configuration process and is also echoed to the output files. The only
possible options are dependencies.</p>
<p>menu:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;menu&quot; &lt;prompt&gt;
&lt;menu options&gt;
&lt;menu block&gt;
&quot;endmenu&quot;
</pre></div>
</div>
<p>This defines a menu block, see “Menu structure” above for more
information. The only possible options are dependencies and “visible”
attributes.</p>
<p>if:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;if&quot; &lt;expr&gt;
&lt;if block&gt;
&quot;endif&quot;
</pre></div>
</div>
<p>This defines an if block. The dependency expression &lt;expr&gt; is appended
to all enclosed menu entries.</p>
<p>source:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;source&quot; &lt;prompt&gt;
</pre></div>
</div>
<p>This reads the specified configuration file. This file is always parsed.</p>
<p>mainmenu:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>&quot;mainmenu&quot; &lt;prompt&gt;
</pre></div>
</div>
<p>This sets the config program’s title bar if the config program chooses
to use it. It should be placed at the top of the configuration, before any
other statement.</p>
<p>‘#’ Kconfig source file comment:</p>
<p>An unquoted ‘#’ character anywhere in a source file line indicates
the beginning of a source file comment.  The remainder of that line
is a comment.</p>
</div>
<div class="section" id="kconfig-hints">
<h2>Kconfig hints<a class="headerlink" href="#kconfig-hints" title="Permalink to this headline">¶</a></h2>
<p>This is a collection of Kconfig tips, most of which aren’t obvious at
first glance and most of which have become idioms in several Kconfig
files.</p>
<div class="section" id="adding-common-features-and-make-the-usage-configurable">
<h3>Adding common features and make the usage configurable<a class="headerlink" href="#adding-common-features-and-make-the-usage-configurable" title="Permalink to this headline">¶</a></h3>
<p>It is a common idiom to implement a feature/functionality that are
relevant for some architectures but not all.
The recommended way to do so is to use a config variable named HAVE_*
that is defined in a common Kconfig file and selected by the relevant
architectures.
An example is the generic IOMAP functionality.</p>
<p>We would in lib/Kconfig see:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span># Generic IOMAP is used to ...
config HAVE_GENERIC_IOMAP

config GENERIC_IOMAP
      depends on HAVE_GENERIC_IOMAP &amp;&amp; FOO
</pre></div>
</div>
<p>And in lib/Makefile we would see:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>obj-$(CONFIG_GENERIC_IOMAP) += iomap.o
</pre></div>
</div>
<p>For each architecture using the generic IOMAP functionality we would see:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config X86
      select ...
      select HAVE_GENERIC_IOMAP
      select ...
</pre></div>
</div>
<p>Note: we use the existing config option and avoid creating a new
config variable to select HAVE_GENERIC_IOMAP.</p>
<p>Note: the use of the internal config variable HAVE_GENERIC_IOMAP, it is
introduced to overcome the limitation of select which will force a
config option to ‘y’ no matter the dependencies.
The dependencies are moved to the symbol GENERIC_IOMAP and we avoid the
situation where select forces a symbol equals to ‘y’.</p>
</div>
<div class="section" id="adding-features-that-need-compiler-support">
<h3>Adding features that need compiler support<a class="headerlink" href="#adding-features-that-need-compiler-support" title="Permalink to this headline">¶</a></h3>
<p>There are several features that need compiler support. The recommended way
to describe the dependency on the compiler feature is to use “depends on”
followed by a test macro:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config STACKPROTECTOR
      bool &quot;Stack Protector buffer overflow detection&quot;
      depends on $(cc-option,-fstack-protector)
      ...
</pre></div>
</div>
<p>If you need to expose a compiler capability to makefiles and/or C source files,
<cite>CC_HAS_</cite> is the recommended prefix for the config option:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config CC_HAS_STACKPROTECTOR_NONE
      def_bool $(cc-option,-fno-stack-protector)
</pre></div>
</div>
</div>
<div class="section" id="build-as-module-only">
<h3>Build as module only<a class="headerlink" href="#build-as-module-only" title="Permalink to this headline">¶</a></h3>
<p>To restrict a component build to module-only, qualify its config symbol
with “depends on m”.  E.g.:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>config FOO
      depends on BAR &amp;&amp; m
</pre></div>
</div>
<p>limits FOO to module (=m) or disabled (=n).</p>
</div>
<div class="section" id="kconfig-recursive-dependency-limitations">
<h3>Kconfig recursive dependency limitations<a class="headerlink" href="#kconfig-recursive-dependency-limitations" title="Permalink to this headline">¶</a></h3>
<p>If you’ve hit the Kconfig error: “recursive dependency detected” you’ve run
into a recursive dependency issue with Kconfig, a recursive dependency can be
summarized as a circular dependency. The kconfig tools need to ensure that
Kconfig files comply with specified configuration requirements. In order to do
that kconfig must determine the values that are possible for all Kconfig
symbols, this is currently not possible if there is a circular relation
between two or more Kconfig symbols. For more details refer to the “Simple
Kconfig recursive issue” subsection below. Kconfig does not do recursive
dependency resolution; this has a few implications for Kconfig file writers.
We’ll first explain why this issues exists and then provide an example
technical limitation which this brings upon Kconfig developers. Eager
developers wishing to try to address this limitation should read the next
subsections.</p>
</div>
<div class="section" id="simple-kconfig-recursive-issue">
<h3>Simple Kconfig recursive issue<a class="headerlink" href="#simple-kconfig-recursive-issue" title="Permalink to this headline">¶</a></h3>
<p>Read: Documentation/kbuild/Kconfig.recursion-issue-01</p>
<p>Test with:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>make KBUILD_KCONFIG=Documentation/kbuild/Kconfig.recursion-issue-01 allnoconfig
</pre></div>
</div>
</div>
<div class="section" id="cumulative-kconfig-recursive-issue">
<h3>Cumulative Kconfig recursive issue<a class="headerlink" href="#cumulative-kconfig-recursive-issue" title="Permalink to this headline">¶</a></h3>
<p>Read: Documentation/kbuild/Kconfig.recursion-issue-02</p>
<p>Test with:</p>
<div class="highlight-none"><div class="highlight"><pre><span></span>make KBUILD_KCONFIG=Documentation/kbuild/Kconfig.recursion-issue-02 allnoconfig
</pre></div>
</div>
</div>
<div class="section" id="practical-solutions-to-kconfig-recursive-issue">
<h3>Practical solutions to kconfig recursive issue<a class="headerlink" href="#practical-solutions-to-kconfig-recursive-issue" title="Permalink to this headline">¶</a></h3>
<p>Developers who run into the recursive Kconfig issue have two options
at their disposal. We document them below and also provide a list of
historical issues resolved through these different solutions.</p>
<blockquote>
<div><ol class="loweralpha">
<li><p class="first">Remove any superfluous “select FOO” or “depends on FOO”</p>
</li>
<li><p class="first">Match dependency semantics:</p>
<blockquote>
<div><p>b1) Swap all “select FOO” to “depends on FOO” or,</p>
<p>b2) Swap all “depends on FOO” to “select FOO”</p>
</div></blockquote>
</li>
</ol>
</div></blockquote>
<p>The resolution to a) can be tested with the sample Kconfig file
Documentation/kbuild/Kconfig.recursion-issue-01 through the removal
of the “select CORE” from CORE_BELL_A_ADVANCED as that is implicit already
since CORE_BELL_A depends on CORE. At times it may not be possible to remove
some dependency criteria, for such cases you can work with solution b).</p>
<p>The two different resolutions for b) can be tested in the sample Kconfig file
Documentation/kbuild/Kconfig.recursion-issue-02.</p>
<p>Below is a list of examples of prior fixes for these types of recursive issues;
all errors appear to involve one or more select’s and one or more “depends on”.</p>
<table border="1" class="docutils">
<colgroup>
<col width="26%" />
<col width="74%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">commit</th>
<th class="head">fix</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>06b718c01208</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>c22eacfe82f9</td>
<td>depends on A -&gt; depends on B</td>
</tr>
<tr class="row-even"><td>6a91e854442c</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>118c565a8f2e</td>
<td>select A -&gt; select B</td>
</tr>
<tr class="row-even"><td>f004e5594705</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>c7861f37b4c6</td>
<td>depends on A -&gt; (null)</td>
</tr>
<tr class="row-even"><td>80c69915e5fb</td>
<td>select A -&gt; (null)              (1)</td>
</tr>
<tr class="row-odd"><td>c2218e26c0d0</td>
<td>select A -&gt; depends on A        (1)</td>
</tr>
<tr class="row-even"><td>d6ae99d04e1c</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>95ca19cf8cbf</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-even"><td>8f057d7bca54</td>
<td>depends on A -&gt; (null)</td>
</tr>
<tr class="row-odd"><td>8f057d7bca54</td>
<td>depends on A -&gt; select A</td>
</tr>
<tr class="row-even"><td>a0701f04846e</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>0c8b92f7f259</td>
<td>depends on A -&gt; (null)</td>
</tr>
<tr class="row-even"><td>e4e9e0540928</td>
<td>select A -&gt; depends on A        (2)</td>
</tr>
<tr class="row-odd"><td>7453ea886e87</td>
<td>depends on A &gt; (null)           (1)</td>
</tr>
<tr class="row-even"><td>7b1fff7e4fdf</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>86c747d2a4f0</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-even"><td>d9f9ab51e55e</td>
<td>select A -&gt; depends on A</td>
</tr>
<tr class="row-odd"><td>0c51a4d8abd6</td>
<td>depends on A -&gt; select A        (3)</td>
</tr>
<tr class="row-even"><td>e98062ed6dc4</td>
<td>select A -&gt; depends on A        (3)</td>
</tr>
<tr class="row-odd"><td>91e5d284a7f1</td>
<td>select A -&gt; (null)</td>
</tr>
</tbody>
</table>
<ol class="arabic simple">
<li>Partial (or no) quote of error.</li>
<li>That seems to be the gist of that fix.</li>
<li>Same error.</li>
</ol>
</div>
<div class="section" id="future-kconfig-work">
<h3>Future kconfig work<a class="headerlink" href="#future-kconfig-work" title="Permalink to this headline">¶</a></h3>
<p>Work on kconfig is welcomed on both areas of clarifying semantics and on
evaluating the use of a full SAT solver for it. A full SAT solver can be
desirable to enable more complex dependency mappings and / or queries,
for instance on possible use case for a SAT solver could be that of handling
the current known recursive dependency issues. It is not known if this would
address such issues but such evaluation is desirable. If support for a full SAT
solver proves too complex or that it cannot address recursive dependency issues
Kconfig should have at least clear and well defined semantics which also
addresses and documents limitations or requirements such as the ones dealing
with recursive dependencies.</p>
<p>Further work on both of these areas is welcomed on Kconfig. We elaborate
on both of these in the next two subsections.</p>
</div>
<div class="section" id="semantics-of-kconfig">
<h3>Semantics of Kconfig<a class="headerlink" href="#semantics-of-kconfig" title="Permalink to this headline">¶</a></h3>
<p>The use of Kconfig is broad, Linux is now only one of Kconfig’s users:
one study has completed a broad analysis of Kconfig use in 12 projects <a class="footnote-reference" href="#id7" id="id1">[0]</a>.
Despite its widespread use, and although this document does a reasonable job
in documenting basic Kconfig syntax a more precise definition of Kconfig
semantics is welcomed. One project deduced Kconfig semantics through
the use of the xconfig configurator <a class="footnote-reference" href="#id8" id="id2">[1]</a>. Work should be done to confirm if
the deduced semantics matches our intended Kconfig design goals.</p>
<p>Having well defined semantics can be useful for tools for practical
evaluation of depenencies, for instance one such use known case was work to
express in boolean abstraction of the inferred semantics of Kconfig to
translate Kconfig logic into boolean formulas and run a SAT solver on this to
find dead code / features (always inactive), 114 dead features were found in
Linux using this methodology <a class="footnote-reference" href="#id8" id="id3">[1]</a> (Section 8: Threats to validity).</p>
<p>Confirming this could prove useful as Kconfig stands as one of the the leading
industrial variability modeling languages <a class="footnote-reference" href="#id8" id="id4">[1]</a> <a class="footnote-reference" href="#id9" id="id5">[2]</a>. Its study would help
evaluate practical uses of such languages, their use was only theoretical
and real world requirements were not well understood. As it stands though
only reverse engineering techniques have been used to deduce semantics from
variability modeling languages such as Kconfig <a class="footnote-reference" href="#id10" id="id6">[3]</a>.</p>
<table class="docutils footnote" frame="void" id="id7" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id1">[0]</a></td><td><a class="reference external" href="http://www.eng.uwaterloo.ca/~shshe/kconfig_semantics.pdf">http://www.eng.uwaterloo.ca/~shshe/kconfig_semantics.pdf</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id8" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label">[1]</td><td><em>(<a class="fn-backref" href="#id2">1</a>, <a class="fn-backref" href="#id3">2</a>, <a class="fn-backref" href="#id4">3</a>)</em> <a class="reference external" href="http://gsd.uwaterloo.ca/sites/default/files/vm-2013-berger.pdf">http://gsd.uwaterloo.ca/sites/default/files/vm-2013-berger.pdf</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id9" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id5">[2]</a></td><td><a class="reference external" href="http://gsd.uwaterloo.ca/sites/default/files/ase241-berger_0.pdf">http://gsd.uwaterloo.ca/sites/default/files/ase241-berger_0.pdf</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id10" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id6">[3]</a></td><td><a class="reference external" href="http://gsd.uwaterloo.ca/sites/default/files/icse2011.pdf">http://gsd.uwaterloo.ca/sites/default/files/icse2011.pdf</a></td></tr>
</tbody>
</table>
</div>
<div class="section" id="full-sat-solver-for-kconfig">
<h3>Full SAT solver for Kconfig<a class="headerlink" href="#full-sat-solver-for-kconfig" title="Permalink to this headline">¶</a></h3>
<p>Although SAT solvers <a class="footnote-reference" href="#id17" id="id11">[4]</a> haven’t yet been used by Kconfig directly, as noted
in the previous subsection, work has been done however to express in boolean
abstraction the inferred semantics of Kconfig to translate Kconfig logic into
boolean formulas and run a SAT solver on it <a class="footnote-reference" href="#id18" id="id12">[5]</a>. Another known related project
is CADOS <a class="footnote-reference" href="#id19" id="id13">[6]</a> (former VAMOS <a class="footnote-reference" href="#id20" id="id14">[7]</a>) and the tools, mainly undertaker <a class="footnote-reference" href="#id21" id="id15">[8]</a>, which
has been introduced first with <a class="footnote-reference" href="#id22" id="id16">[9]</a>.  The basic concept of undertaker is to
exract variability models from Kconfig, and put them together with a
propositional formula extracted from CPP #ifdefs and build-rules into a SAT
solver in order to find dead code, dead files, and dead symbols. If using a SAT
solver is desirable on Kconfig one approach would be to evaluate repurposing
such efforts somehow on Kconfig. There is enough interest from mentors of
existing projects to not only help advise how to integrate this work upstream
but also help maintain it long term. Interested developers should visit:</p>
<p><a class="reference external" href="http://kernelnewbies.org/KernelProjects/kconfig-sat">http://kernelnewbies.org/KernelProjects/kconfig-sat</a></p>
<table class="docutils footnote" frame="void" id="id17" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id11">[4]</a></td><td><a class="reference external" href="http://www.cs.cornell.edu/~sabhar/chapters/SATSolvers-KR-Handbook.pdf">http://www.cs.cornell.edu/~sabhar/chapters/SATSolvers-KR-Handbook.pdf</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id18" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id12">[5]</a></td><td><a class="reference external" href="http://gsd.uwaterloo.ca/sites/default/files/vm-2013-berger.pdf">http://gsd.uwaterloo.ca/sites/default/files/vm-2013-berger.pdf</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id19" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id13">[6]</a></td><td><a class="reference external" href="https://cados.cs.fau.de">https://cados.cs.fau.de</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id20" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id14">[7]</a></td><td><a class="reference external" href="https://vamos.cs.fau.de">https://vamos.cs.fau.de</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id21" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id15">[8]</a></td><td><a class="reference external" href="https://undertaker.cs.fau.de">https://undertaker.cs.fau.de</a></td></tr>
</tbody>
</table>
<table class="docutils footnote" frame="void" id="id22" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id16">[9]</a></td><td><a class="reference external" href="https://www4.cs.fau.de/Publications/2011/tartler_11_eurosys.pdf">https://www4.cs.fau.de/Publications/2011/tartler_11_eurosys.pdf</a></td></tr>
</tbody>
</table>
</div>
</div>
</div>


           </div>
           <div class="articleComments">
            
           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2019, The Xen development community.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../',
            VERSION:'4.16-unstable',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="../_static/jquery.js"></script>
      <script type="text/javascript" src="../_static/underscore.js"></script>
      <script type="text/javascript" src="../_static/doctools.js"></script>

  

  
  
    <script type="text/javascript" src="../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>